/* Generated automatically by jlpp - do not edit. */

#include <jakelib2.h>
static jakelib::lang::String* jakelib2_strings[] = {null};

// " = "
static jchar chars_jakelib2_str_0[] = {32,61,32};
#line 1 "util/Properties.jlc"
// -*- c++ -*-

/*
 * Jakelib2 - General purpose C++ library
 * Copyright (C) 2001 Florian Wolff  (florian@donuz.de)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: Properties.jlc,v 1.5 2003/09/23 14:22:42 florian Exp $
 */


#include "jakelib2/jakelib2.h"
#include "jakelib2/util/Properties.h"
#include "jakelib2/io/OutputStreamWriter.h"
#include "jakelib2/io/BufferedReader.h"
#include "jakelib2/io/BufferedWriter.h"
#include "jakelib2/io/FileInputStream.h"
#include "jakelib2/io/InputStreamReader.h"
#include "jakelib2/io/OutputStreamWriter.h"
#include "jakelib2/util/HashEntry.h"

using namespace jakelib::util;
using namespace jakelib::lang;
using namespace jakelib::io;

JAKELIB_IMPLEMENT_CLASS("jakelib.util.Properties", Properties, Hashtable)


/*****************************************************************************\
 * Properties                                                                 |
 *****************************************************************************/
Properties::Properties() : Hashtable(100, 0.75F)
{
   defaults = null;
}

Properties::Properties(Properties* defaults) 
  : Hashtable(100, 0.75F)
{
   this->defaults = defaults;
}


/*****************************************************************************\
 * getProperty                                                                |
 *****************************************************************************/
String* Properties::getProperty(String* key)
{
  String* ret = (String*) get(key);

  if (ret == null) {
    if (defaults != null)
      return defaults->getProperty(key);
    else
      return null;
  }
  else {
    return ret;
  }
}

String* Properties::getProperty(char* key)
{ 
  String keyStr = String(key);
  
  String* ret = getProperty(&keyStr);
  if (ret == null && defaults != null) {
    return defaults->getProperty(&keyStr);
  }
  else
    return ret;
}

String* Properties::getProperty(char* key, char* defaultValue)
{ 
  String keyStr = String(key);

  String* ret = getProperty(&keyStr);
  
  if (ret == null) {
    if (defaults != null) {
      ret = defaults->getProperty(&keyStr);
    }
    if (ret == null)
      return new String(defaultValue);
    else
      return ret;
  }
  else {
    return ret;
  }
}

String* Properties::getProperty(String* key, String* defaultValue)
{
  String* ret = (String*) get(key);

  if (ret == null) {
    String* ret = null;
    if (defaults != null)
      ret = defaults->getProperty(key);
    if (ret == null)
      return defaultValue;
    else
      return ret;
  }
  else
    return ret;
}


/*****************************************************************************\
 * setProperty                                                                |
 *****************************************************************************/
void Properties::setProperty(String* key, String* value)
{
  put(key, value);
}

void Properties::setProperty(char* key, char* value)
{
  put(new String(key), new String(value));
}


/*****************************************************************************\
 * load                                                                       |
 *****************************************************************************/
void Properties::load(BufferedReader* in)
{
  String* prevString = null;
  
  while (true) {
    String* line = in->readLine();
    if (line == null)
      break;
    if (line->length() == 0)
      continue;
    
    if (prevString != null) {
      // Continue previous line:
      
      line = line->trim();
      if (line->endsWith("\\") && (line->length() == 1 || line->charAt(line->length() -2) != '\\')) {
 line = line->substring(0, line->length() -1);
 prevString = prevString->plus(line);
      }
      else {
 prevString = null;
      }
    }
    else {
      // This is a new line:
      int pos = line->indexOf('=');
      if (pos != -1) {
 String* key = line->substring(0, pos)->trim();
 if (! (key->charAt(0) == '#' ||
        key->charAt(0) == ';')    ) {
   String* value = line->substring(pos +1);
   String* valuePtr;
   
   value = value->trim();
   if (value->endsWith("\\") && (value->length() == 1 || value->charAt(value->length() -2) != '\\')) {
     value = value->substring(0, value->length() -1);
     valuePtr = prevString = value->parseCppString();
   }
   else {
     prevString = null;
     valuePtr = value->parseCppString();
   }
   setProperty(key, valuePtr);
 }
 else {
   prevString = null;
 }
      }
      else {
 prevString = null;
      }
    }
  }
}

void Properties::load(char* filename)
{
  FileInputStream input(filename);
  InputStreamReader streamReader(&input);
  BufferedReader reader(&streamReader);
  load(&reader);
}

void Properties::load(String* filename)
{
  load(filename->latin1());
}


/*****************************************************************************\
 * store                                                                      |
 *****************************************************************************/
void Properties::store(OutputStream* out, String* header)
{
  String* key;
  String* value;
  HashEntry* e;
  OutputStreamWriter writer(out);
  BufferedWriter bw = BufferedWriter(&writer);

  bw.write("# ");
  bw.write(header);
  bw.newLine();
  bw.write("#");
  bw.newLine();
  bw.newLine();

  for (int idx = 0; idx < capacity; idx++) {
    e = table[idx];
    if (e != null) {
      key = (String*) e->key;
      value = (String*) e->value;
      bw.write(key);
      bw.write(JAKELIB_ONDEMAND(jakelib2_strings[0], new jakelib::lang::String(chars_jakelib2_str_0, 0, 3)));
      bw.write(value->toCppString());
      //bw.write('\"');
      bw.newLine();
    }
  }
  bw.close();
}


/*****************************************************************************\
 * getBoolean                                                                 |
 *****************************************************************************/
jboolean Properties::getBoolean(char* key, jboolean defaultValue)
{
  String* value = getProperty(key);

  if (value == null) {
    return defaultValue;
  }
  else {
    String* v = value->toLowerCase();
    if (v->equals("1") || v->equals("true") || v->equals("on") || v->equals("yes")) {
      return true;
    }
    else {
      return false;
    }
  }
}


jboolean Properties::getBoolean(String* key, jboolean defaultValue)
{
  return getBoolean(key->latin1(), defaultValue);
}


/*****************************************************************************\
 * getInt                                                                     |
 *****************************************************************************/
int Properties::getInt(char* key, int defaultValue)
{
  String* value = getProperty(key);

  if (value == null) {
    return defaultValue;
  }
  else {
    return value->toInt();
  }
}


int Properties::getInt(String* key, int defaultValue)
{
  return getInt(key->latin1(), defaultValue);
}




